RawSquareFreeIdeal.cpp File Reference
`#include "stdinc.h"`
`#include "RawSquareFreeIdeal.h"`
`#include "Arena.h"`
`#include "Ideal.h"`
`#include "RawSquareFreeTerm.h"`
`#include "BigIdeal.h"`
`#include <limits>`
`#include <algorithm>`
`#include <sstream>`
`#include <cstring>`

Go to the source code of this file.

## Typedefs

typedef RawSquareFreeIdeal | RSFIdeal

## Functions

static void | countVarDividesBlockUpTo15 (const Word *it, size_t genCount, const size_t wordsPerTerm, size_t *counts)
RSFIdeal * | newRawSquareFreeIdeal (size_t varCount, size_t capacity)
| Allocates object with enough memory for capacity generators in varCount variables.
RawSquareFreeIdeal * | newRawSquareFreeIdeal (const RawSquareFreeIdeal &ideal)
| Allocates a copy of ideal with no extra capacity.
RawSquareFreeIdeal * | newRawSquareFreeIdealParse (const char *str)
| Allocates and returns an ideal based on str.
void | deleteRawSquareFreeIdeal (RSFIdeal *ideal)

## Typedef Documentation

## RSFIdeal

typedef RawSquareFreeIdeal RSFIdeal

Definition at line 30 of file RawSquareFreeIdeal.cpp.

## Function Documentation

## countVarDividesBlockUpTo15()

void countVarDividesBlockUpTo15 | ( | const Word * | it,
|  | size_t | genCount,
|  | const size_t | wordsPerTerm,
|  | size_t * | counts )

inline static

Definition at line 317 of file RawSquareFreeIdeal.cpp.

## deleteRawSquareFreeIdeal()

void deleteRawSquareFreeIdeal | ( | RSFIdeal * | ideal | ) |

Definition at line 840 of file RawSquareFreeIdeal.cpp.

## newRawSquareFreeIdeal() [1/2]

RawSquareFreeIdeal * newRawSquareFreeIdeal | ( | const RawSquareFreeIdeal & | ideal | ) |

Allocates a copy of ideal with no extra capacity.

Definition at line 807 of file RawSquareFreeIdeal.cpp.

## newRawSquareFreeIdeal() [2/2]

RSFIdeal * newRawSquareFreeIdeal | ( | size_t | varCount,
|  | size_t | capacity )

Allocates object with enough memory for capacity generators in varCount variables.

Pointer must be deallocated using deleteRawSquareFreeIdeal.

Definition at line 797 of file RawSquareFreeIdeal.cpp.

## newRawSquareFreeIdealParse()

RawSquareFreeIdeal * newRawSquareFreeIdealParse | ( | const char * | str | ) |

Allocates and returns an ideal based on str.

The returned ideal must be deallocated using deleteRawSquareFreeIdeal. str is parsed with a generator on each line as parsed by newTermParse. Results are undefined if str does not have that format.

The parsing is inefficient and is intended for constructing ideals in testing.

Definition at line 819 of file RawSquareFreeIdeal.cpp.